SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Tests'!

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 5/20/2010 18:24:23.891'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	(SyOperation shouldBeReplicated: (self selector)) ifTrue: [
		instrumentor ifNotNil: [
			instrumentor methodCalled: (self selector) on: anObject with: anArrayOfObjects resulting: result.
		].
	].
	^ result! !

Object subclass: #Person
	instanceVariableNames: 'givenName surname birthday address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'SR 5/15/2010 15:24:16.133'!
= anObject 

	^ (self givenName = anObject givenName) and: [self surname = anObject surname] and: [self birthday = anObject birthday] and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:51.253'!
address: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	address := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:27:34.621'!
birthday: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	birthday := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'classes methods processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:27:33.49'!
instrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self instrumentedClasses add: c.
			c selectors do: [:selector | self instrumentMethod: selector inClass: c ]
		]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:19:22.051'!
instrumentMethod: selector inClass: aClass

	| wrapper |
	(self isMethodInstrumented: selector inClass: aClass)  ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			wrapper := SyMethodWrapper on: selector inClass: aClass for: self.
			wrapper install.
		].
		(self instrumentedMethodsAt: aClass) add: selector.
	].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:23:09.66'!
instrumentedClasses

	^ classes ifNil: [classes := WeakSet new]! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:14.84'!
instrumentedMethods

	^ methods ifNil: [methods := WeakKeyDictionary new] ! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:05.214'!
instrumentedMethodsAt: aClass

	^ self instrumentedMethods at: aClass ifAbsentPut: [Set new]! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:39.999'!
isClassInstrumented: aClass

	^ self instrumentedClasses includes: aClass! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:48.289'!
isMethodInstrumented: selector inClass: aClass

	^ (self instrumentedMethods at: aClass ifAbsent: [Array empty]) includes: selector! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/17/2010 19:49:01.808'!
methodCalled: aSelector on: anObject with: anArrayOfObjects resulting: result

	self processor ifNotNil: [ self processor process: aSelector on: anObject with: anArrayOfObjects ].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:36:25.493'!
uninstrumentAllAndReset

	self instrumentedClasses do: [:ea | 
		self uninstrumentClass: ea.
	].

	self instrumentedMethods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | 
			self uninstrumentMethod: (aClass >> s).
		].
	].

	self instrumentedMethods keysAndValuesRemove: [:k :v | true ].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:37:17.823'!
uninstrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifTrue: [
		self instrumentedClasses remove: aClass.
		self instrumentedClasses remove: metaClass ifAbsent: []
	].
	
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:20:18.101'!
uninstrumentMethod: aCompiledMethod

	| registeredMethods aClass selector |
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.

	(self isMethodInstrumented: selector inClass: aClass)  ifTrue: [
		aCompiledMethod isMwMethodWrapper ifTrue: [	
			aCompiledMethod uninstall.
		].
	
		registeredMethods := self instrumentedMethodsAt: aClass.
		registeredMethods remove: selector.
		registeredMethods ifEmpty: [self instrumentedMethods removeKey: aClass].
	].! !

Object subclass: #SyOperation
	instanceVariableNames: 'selector receiverUUID arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyOperation class methodsFor: 'instance creation' stamp: 'SR 5/17/2010 20:14:46.955'!
receiver: aUUID selector: aSelector arguments: anArray

	^ self new
		receiverUUID: aUUID;
		selector: aSelector;
		arguments: anArray;
		yourself
		! !

!SyOperation class methodsFor: 'instance creation' stamp: 'SR 5/20/2010 18:25:43.164'!
shouldBeReplicated: aSelector

	^ ({#=.} includes: aSelector) not! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.632'!
arguments
	^ arguments! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.644'!
arguments: anObject
	arguments := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.664'!
receiverUUID
	^ receiverUUID! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.676'!
receiverUUID: anObject
	receiverUUID := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.177'!
selector
	^ selector! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.189'!
selector: anObject
	selector := anObject! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/19/2010 13:02:18.545'!
processDataFrom: aStream
	"Hint: Expect stream API from SocketStream. Other Streams should work as well."
	
	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:28:03.24'!
sendOperationNonBlocking: anOperation to: aStream
	"Sends an Operation to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'isServer outgoingQueue outgoingQueueWorker repository currentCommandResultCache currentCommandResultSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor class methodsFor: 'channel-numbers' stamp: 'SR 5/25/2010 18:45:29.7'!
commandChannelNumber

	^ 100! !

!SySimpleProtocolProcessor class methodsFor: 'instance creation' stamp: 'SR 5/25/2010 17:24:26.827'!
on: aRepository

	^ self new
		repository: aRepository;
		isServer: false;
		yourself.! !

!SySimpleProtocolProcessor class methodsFor: 'instance creation' stamp: 'SR 5/25/2010 17:24:36.416'!
serverOn: aRepository

	^ self new
		repository: aRepository;
		isServer: true;
		yourself.! !

!SySimpleProtocolProcessor class methodsFor: 'channel-numbers' stamp: 'SR 5/25/2010 18:45:25.416'!
updateChannelNumber

	^ 200! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'SR 5/25/2010 18:22:34.961'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new.
	currentCommandResultSemaphore := Semaphore new.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/25/2010 17:24:50.746'!
isServer

	^ isServer! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/25/2010 17:24:58.653'!
isServer: anObject

	isServer := anObject! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:02.8'!
killOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifFalse: [ outgoingQueueWorker terminate ].! !

!SySimpleProtocolProcessor methodsFor: 'commands' stamp: 'SR 5/25/2010 17:50:43.704'!
list: aStream

	| response rawResponse |
	rawResponse := self sendCommandBlocking: 'list' on: aStream.
	response := Json readFrom: (ReadStream on: rawResponse).
	
	^ response collect: [ :data | self pvtCreateRegisteredObject: data ].! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 5/25/2010 18:56:58.012'!
processDataFrom: aStream
	"Depending on the channel, process the data"
	
	| line |
	line := self receiveFrom: aStream.

	((line at: #number) = self class updateChannelNumber) ifTrue: [
		^ self pvtProcessUpdate: (line at: #data) from: aStream.
	].

	((line at: #number) = self class commandChannelNumber) ifTrue: [
		^ self isServer
			ifTrue: [ self pvtProcessCommand: (line at: #data) from: aStream ]
			ifFalse: [ self pvtProcessCommandResult: (line at: #data) from: aStream ].
	].
		! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:07.046'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifTrue: [
		outgoingQueueWorker := [ 
			[ outgoingQueue isEmpty] whileFalse: [ | opArray operationDict data |
				opArray := outgoingQueue next.
				operationDict := self pvtCreateOperationDictionary: (opArray first).
				data := Json render: operationDict.
				self send: data in: (self class updateChannelNumber) on: (opArray second).
			].
		] fork.
	].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/20/2010 18:11:58.135'!
pvtCreateObjectDictionary: anRegisteredObject

	^ Dictionary new
		at: 'type' put: 'object';
		at: 'uuid' put: (anRegisteredObject uuid);
		at: 'class' put: (anRegisteredObject client className);
		at: 'data' put: (anRegisteredObject client instanceVariableValues);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 18:58:13.463'!
pvtCreateOperation: aDictionary

	^ SyOperation new
		receiverUUID: (aDictionary at: 'uuid');
		selector: ((aDictionary at: 'selector') asSymbol);
		arguments: (aDictionary at: 'arguments');
		yourself.	! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/20/2010 18:13:26.797'!
pvtCreateOperationDictionary: aSyOperation

	^ Dictionary new
		at: 'type' put: 'operation';
		at: 'uuid' put: (aSyOperation receiverUUID);
		at: 'selector' put: (aSyOperation selector asString);
		at: 'arguments' put: (aSyOperation arguments);
		yourself.
	! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 17:45:06.366'!
pvtCreateRegisteredObject: aDictionary

	| uuid typeName variableData newObject |
	((aDictionary at: 'type') = 'object') ifTrue: [
		uuid := aDictionary at: 'uuid'.
		typeName := aDictionary at: 'class'.
		variableData := aDictionary at: 'data'.
	
		newObject := (Smalltalk at: (typeName asSymbol)) new.
		variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
		^  SyRegisteredObject new
			client: newObject;
			uuid: uuid;
			yourself.
	].

	^ nil! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 17:41:51.915'!
pvtCreateRegisteredObjectDictionary: anRegisteredObject

	^ Dictionary new
		at: 'type' put: 'object';
		at: 'uuid' put: (anRegisteredObject uuid);
		at: 'class' put: (anRegisteredObject client className);
		at: 'data' put: (anRegisteredObject client instanceVariableValues);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 5/25/2010 18:13:03.957'!
pvtProcessCommand: aString from: aStream
	"Support commands. Only use in server mode."
	
	"List command: sends back all registered objects current state and id"
	(aString = 'list') ifTrue: [ | objects data |
		"Execute list command: stream all objects to client."
		objects := self repository metaRepository collect: [ :regObject | self pvtCreateObjectDictionary: regObject ].
		data := Json render: objects.
		self send: data in: (self class commandChannelNumber) on: aStream.
		^ true
	].

	"Quit command: closes connection"
	(aString = 'quit') ifTrue: [
		^ false
	].! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 5/25/2010 18:23:45.604'!
pvtProcessCommandResult: aString from: aStream
	"Save the command result and signal. Only use in client mode."
	
	currentCommandResultCache := aString.
	currentCommandResultSemaphore signal.
	
	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 5/25/2010 18:13:31.732'!
pvtProcessUpdate: aString from: aStream
	"Support updates"

	"Deserialize operation"
	
	"Perform it."
	
	"If on server: distribute it"
	self isServer ifTrue: [
	].

	"Never close connection"
	^ true
! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/26/2010 13:13:15.745'!
receiveFrom: aStream

	| line |
	line := aStream upToAll: String crlf.
	^ Dictionary new
		at: #number put: ((line copyUpTo: Character space) asNumber);
		at: #data put: (line copyAfter: Character space);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/25/2010 17:23:43.351'!
repository

	^ repository! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 5/25/2010 17:23:55.666'!
repository: anObject

	repository := anObject! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 17:02:42.181'!
send: aString in: aChannelNumber on: aStream

	aStream nextPutAllFlush: (aChannelNumber asString, ' ', aString, String crlf).
	! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:23:26.222'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."

	| result |
	self send: aCommandString in: (self class commandChannelNumber) on: aStream.
	currentCommandResultSemaphore wait.
	
	result := currentCommandResultCache.
	currentCommandResultCache := nil.
	^ result
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:14.655'!
sendOperationNonBlocking: anOperation to: aStream
	"Only use in client mode."

	outgoingQueue nextPut: {anOperation. aStream.}.
	self pvtCheckOutgoingQueueWorker.
! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.355'!
client
	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.366'!
client: anObject
	client := anObject! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.071'!
operations
	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.083'!
operations: anObject
	operations := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.252'!
uuid
	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.265'!
uuid: anObject
	uuid := anObject! !

Object subclass: #SySimpleClient
	instanceVariableNames: 'socket instrumentor objects protocolProcessor connectionProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/25/2010 18:39:13.283'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/25/2010 18:55:11.657'!
disconnect

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	socket close.
	
	"Clear method wrapper"
	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SySimpleClient methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 21:24:05.185'!
initialize

	super initialize.
	
	objects := OrderedCollection new.
	protocolProcessor := SySimpleProtocolProcessor on: self.
	instrumentor := SyClassInstrumentor new processor: self.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/20/2010 17:37:33.971'!
metaRepository

	^ objects! !

!SySimpleClient methodsFor: 'method wrappers' stamp: 'SR 5/20/2010 17:22:19.095'!
process: aSelector on: anObject with: anArray

	| registeredObject operation |
	registeredObject := objects detect: [ :regObject | regObject client == anObject ] ifNone: [^ self].
	operation := SyOperation receiver: (registeredObject uuid) selector: aSelector arguments: anArray.
	
	registeredObject operations add: operation.
	protocolProcessor sendOperationNonBlocking: operation to: socket.! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/25/2010 17:46:03.764'!
pvtRegister: anRegisteredObject

	(objects contains: [ :o | o == anRegisteredObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	
	objects add: anRegisteredObject.
	
	"Wrap objects class if not yet wrapped"
	instrumentor instrumentClass: (anRegisteredObject client class).! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/17/2010 21:18:18.279'!
pvtUnregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	].! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/25/2010 17:51:41.746'!
pvtUpdateRepository
	"Calls 'list' on the server"

	(protocolProcessor list: socket) do: [ :o | self pvtRegister: o ]! !

!SySimpleClient methodsFor: 'initialize-release' stamp: 'SR 5/25/2010 17:58:36.143'!
release

	self isConnected ifTrue: [ self disconnect ].
	^ super release! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/20/2010 17:16:09.396'!
repository

	^ objects collect: [ :regObject | regObject client ].! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/25/2010 18:38:51.185'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [ self disconnect ].
			(protocolProcessor processDataFrom: socket)
				ifFalse: [ self disconnect ]
		].
	] forkAt: 35.! !

Object subclass: #SySimpleServer
	instanceVariableNames: 'tcpServer objects instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SySimpleServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SySimpleServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SySimpleServer methodsFor: 'initialize-release' stamp: 'mt 5/26/2010 13:04:36.036'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	tcpServer protocolProcessor: (SySimpleProtocolProcessor serverOn: self).
	
	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/20/2010 18:30:12.034'!
metaRepository

	^ objects! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/25/2010 17:32:17.397'!
register: anObject

	| registeredObject |
	(self repository contains: [ :o | o == anObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	registeredObject := SyRegisteredObject new
		client: anObject;
		uuid: (UUID new asString);
		yourself.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	"instrumentor instrumentClass: (anObject class)."! !

!SySimpleServer methodsFor: 'repository' stamp: 'mt 5/26/2010 13:05:08.508'!
repository

	^ objects collect: [ :regObject | regObject client ]! !

!SySimpleServer methodsFor: 'start-stop' stamp: 'mt 5/26/2010 12:59:45.291'!
start

	tcpServer listenOn: self class defaultPort.! !

!SySimpleServer methodsFor: 'start-stop' stamp: 'mt 5/26/2010 12:59:57.809'!
stop

	tcpServer close.! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/25/2010 17:40:56.509'!
unregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	
	"(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	]."! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 5/26/2010 15:43:51.034'!
close

	"Closing listen part"
	listenProcess terminate.
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/28/2010 00:38:31.478'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'rkrk 5/26/2010 15:41:28.56'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 5/27/2010 12:21:08.671'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [connectionProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket) ifFalse: [connectionProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/28/2010 00:38:07.363'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket close.
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

TestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer tcpSocket openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 18:19'!
connectTCPClientToServer

	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	openClientSockets add: tcpSocket.
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 18:15'!
disconnectTCPClientsFromServer

	tcpSocket ifNotNil: [tcpSocket close. tcpSocket := nil].
	openClientSockets do: [:ea | ea close.]! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/15/2010 12:46:22.685'!
maybeWaitForServerThenDo: block

	"sometimes the server is already done before waiting is started so try the block
	first then optionally wait"
	tcpServer connectionChangesMonitor critical: [
		block on: Exception do: [
			Transcript cr;
				show: 'maybeWaitForServerThenDo: first try was failure in ';
					show: self selector.
			tcpServer connectionChangesMonitor wait.
			block value]].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:17'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 5/10/2010 11:39:41.976'!
startTcpServer

	tcpServer ifNil: [tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:40:31.018'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:28.164'!
test04TcpSocketConnection

	self
		startTcpServer;
		connectTCPClientToServer;
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:47.813'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 16:55'!
wait: seconds

	(Delay forSeconds: seconds) wait.! !

TestCase subclass: #SySimpleClientObjectTest
	instanceVariableNames: 'server o1 o2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleClientObjectTest class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 14:41:32.817'!
defaultPort

	^ 22701! !

!SySimpleClientObjectTest methodsFor: 'running' stamp: 'mt 5/26/2010 13:06:14.781'!
setUp

	server := SySimpleServer new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.
	server
		register: o1;
		register: o2;
		start.
		
	sut := SySimpleClient new.! !

!SySimpleClientObjectTest methodsFor: 'running' stamp: 'mt 5/26/2010 13:22:17.503'!
tearDown

	sut disconnect.
	
	server
		unregister: o1;
		unregister: o2;
		stop.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/15/2010 14:52:42.972'!
test01ConnectDisconnect

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	sut disconnect.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/20/2010 17:16:09.462'!
test02GetObjects

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	
	self assert: (sut repository size = 2).
	self assert: (sut repository contains: [:o| o = o1]).
	self assert: (sut repository contains: [:o| o = o2]).
	
	
	sut disconnect.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/25/2010 17:58:18.588'!
test03UnWrapObject

	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut disconnect.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/25/2010 17:57:27.733'!
test04OperationStackTest

	| o1 |
	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	o1 := sut repository first.

	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations isEmpty).
	o1 givenName: 'Test2'.
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations size = 1).
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations first selector = #givenName:).
! !

TestCase subclass: #SySimpleServerObjectRepoTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleServerObjectRepoTests methodsFor: 'running' stamp: 'SR 5/15/2010 12:08:17.176'!
setUp

	super setUp.
	sut := SySimpleServer new.! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/20/2010 17:16:09.427'!
test01UnRegisterObject

	| o1 |
	o1 := Person new.
	self assert: (sut repository isEmpty).
	sut register: o1.
	self assert: (sut repository size = 1).
	sut unregister: o1.
	self assert: (sut repository isEmpty).! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'mt 5/26/2010 12:52:45.402'!
test02DoubleRegistration

	| o1 |
	o1 := Person new.
	self assert: sut repository isEmpty.
	sut register: o1.
	self assert: sut repository size = 1.
	
	self
		should: [sut register: o1]
		raise: Exception.
	
	sut unregister: o1.
! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !
